<template>
  <div class="mx-auto uc-section user-section-container 2xl:my-[90px] xl:my-[50px] lg:my-10 my-6" :class="{ 'is-collapse': isCollapse }" >
    <div class="uc-section-title-container">
      <div class="flex items-center uc-section-title" id="header">
        <div class="display_bloc mr-4">
          <nuxt-link to="/">
            <font-awesome-icon :icon="['fas', 'chevron-left']" />
          </nuxt-link>
        </div>

        <div>
          <h3>{{ $t("user_center") }} / {{ title }}</h3>
        </div>
      </div>
    </div>
    <div class="flex w-full uc-section-content">
      <div
        :class="['uc-section-left display_none', { 'is-collapse': isCollapse }]"
      >
        <div>
          <button type="button" class="expand-btn" @click="onToggleMenu">
            <font-awesome-icon class="expend-sign" :icon="['fas', 'chevron-left']" />
            <font-awesome-icon class="collapse-sign" :icon="['fas', 'chevron-right']" />
          </button>
          <div class="menu-content">
            <nuxt-link
              v-for="tab in tabs"
              :key="tab.to"
              :to="tab.to"
              class="uc-tab"
              :class="{ selected: checkActiveLink(tab.to) }"
              @click="onRouterClick"
              :id="`uc${upperFirst(camelCase(tab.label))}Tab`"
            >
              <div class="menu-item pointer-events-none">
                <SvgIcon :svg-name="tab.icon" />
                <span class="label">{{ $t(tab.label) }}</span>
                <MessagesMessageCount
                  v-if="unreadInfo && unreadInfo.TotalCount && tab.label === 'messages'"
                  :count="unreadInfo.TotalCount"
                  :is-unread="true"
                  class="!ml-0"
                ></MessagesMessageCount>
              </div>
            </nuxt-link>
          </div>
        </div>
        <div class="logout-section w-full flex flex-col justify-center">
          <div class="divider"></div>
          <el-button
            class="logout-btn py-1 text-sm w-full rounded btn bg-secondary"
            :disabled="isLoading"
            :loading="isLoading"
            @click="logout"
          >
            <template #icon>
              <span class="ml-1">
                <SvgIcon svg-name="icon-sign-out" />
              </span>
            </template>
            <template #default>
              <span class="label">{{ $t("logout") }}</span>
            </template>
          </el-button>
        </div>
      </div>
      <div
        class="relative uc-section-right w-full min-h-[720px] overflow-x-auto ol-bg-light"
      >
        <div class="flex-auto h-full relative user-center">
          <div class="bg-cover absolute w-full h-full inset-0 bg-black opacity-10 z-0"></div>
          <slot />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import useMenu from "@/composables/useMenu";
import { store } from "~~/store";
import { appStore } from '~~/store/app';
import { camelCase, upperFirst } from "lodash-es";
defineProps({
  title: {
    type: String,
    default: "",
  },
});

const emit = defineEmits(["routerClicked"]);
const {
  isCashPlayer,
  isShowDepositWithdrawal,
  isShowPromotion,
  isShowReferral,
} = useMenu();

const { logout, isLoading, isReferralV2Enabled } = useHeaderComponent();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  { to: "/wallet", label: "wallet", icon: "icon-wallet", display: true },
  { to: "/account", label: "account", icon: "icon-account", display: true },
  {
    to: "/transaction-history",
    label: "statement",
    icon: "icon-transaction",
    display: true,
  },
  {
    to: "/bet-history",
    label: "bet_history",
    icon: "icon-bethistory",
    display: true,
  },
  {
    to: "/my-promotion",
    label: "promotion",
    icon: "icon-promotion",
    display: isShowPromotion.value,
  },
  {
    to: "/referral",
    label: "referral",
    icon: "icon-referral",
    display: isCashPlayer.value && isShowReferral.value && !isReferralV2Enabled.value,
  },
  {
    to: "/referral-v2",
    label: "referral",
    icon: "icon-referral",
    display: isReferralV2Enabled.value && isShowReferralPage,
  },
  {
    to: "/messages",
    label: "messages",
    icon: "message",
    display: true,
  },
]).filter((p) => p.display);

const route = useRoute();
const { fetchMessages, unreadInfo } = useMessage();
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
const checkActiveLink = (link: string) => {
  const string = `^${link}`;
  return new RegExp(string).test(route.path);
};

const onRouterClick = () => {
  emit("routerClicked");
};
const isCollapse = ref(true);
const onToggleMenu = () => {
  isCollapse.value = !isCollapse.value;
};
</script>
<style>
.uc-section .el-loading-mask {
  background: transparent;
}
.uc-section .el-table__empty-block {
  border: var(--el-table-border);
  border-bottom-left-radius: 8px;
  border-bottom-right-radius: 8px;
  border-top: unset;
  height: auto !important;
  border: var(--el-table-border);
  border-top: unset;
  border-bottom-left-radius: 8px;
  border-bottom-right-radius: 8px;
}

.uc-section .el-table {
  --el-table-border: 2px solid var(--el-table-border-color);
}
.uc-section .el-table--border .el-table__inner-wrapper tr td:first-child {
  border-left: var(--el-table-border);
}
.uc-section .el-table tr th.is-center.el-table__cell {
  border-top: var(--el-table-border);
}
.uc-section .el-table__border-left-patch,
.uc-section .el-table--border::before,
.uc-section .el-table__inner-wrapper::before,
.uc-section .el-table--border .el-table__inner-wrapper::after,
.uc-section .el-table--border::after {
  width: 0;
}
.uc-section tr:first-child th:first-child {
  border-top-left-radius: 8px;
}
.uc-section tr:first-child th:last-child {
  border-top-right-radius: 8px;
}
.uc-section thead tr:not(:first-child) th {
  border-top: unset !important;
}
.uc-section:not(.bet-history) tr:last-child td:first-child {
  border-bottom-left-radius: 8px;
}
.uc-section:not(.bet-history) tr:last-child td:last-child {
  border-bottom-right-radius: 8px;
}
.uc-section.bet-history .el-table__inner-wrapper {
  padding-bottom: 15px;
}
[theme-color="sbo"] .uc-section {
  margin-top: 2.5rem !important;
}
[layout="peru"].account .el-scrollbar {
  height: calc(100dvh - 92px);
}
</style>
<style scoped lang="scss">
.uc-section,
.uc-section :deep(.hidden-desktop-version .el-radio__input:not(.is-checked) + .el-radio__label),
.uc-section :deep(.time-notice-footer),
.uc-section :deep(.fc-text) {
  color: var(--text5);
}
.uc-section :deep(.el-radio:not(:last-child)) {
  margin-right: 16px;
}
.uc-section :deep(.el-button svg) {
  fill: var(--textBtn);
  stroke: var(--textBtn);
  width: 16px;
  height: 16px;
}
.uc-section-left {
  padding: 1rem;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}
.uc-section-left .uc-tab,
.uc-section-left .logout-section {
  // max-width: 84%;
  width: 100%;
}
.uc-section-left .logout-section .divider {
  height: 2px;
  background-color: var(--border);
  margin-bottom: 1rem;
}
// .uc-section-left {
//   padding-top: 1rem;
// }
.uc-section-left,
.uc-section-title-container {
  background: var(--background5);
}
.uc-section-right {
  --bg-base-color: var(--background5);
  --bg-opacity: 0.05;
}

:deep(.uc-section-right .el-scrollbar__view) {
  // height: 100%;
}
.uc-section-title {
  background: rgba(0, 0, 0, 0.2);
  padding: 1rem 2rem;
  border-bottom: solid 2px var(--success);
}
.uc-section-title h3 {
  text-transform: capitalize;
  color: var(--primary);
  font-style: normal;
  font-weight: 900;
  font-size: 24px;
  line-height: 28px;
}
.uc-section {
  border-radius: 16px;
  overflow: hidden;
  display: flex;
  flex-direction: column;
}
.uc-tab-container {
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
  width: 200px;
  align-items: center;
  padding: 1rem;
}
.uc-tab {
  position: relative;
  display: flex;
  gap: 0.625rem;
  padding: 0.75rem 1rem;
  border-radius: 8px;
  align-items: center;
  position: relative;
  font-weight: 500;
  font-size: 14px;
  white-space: nowrap;
  height: 48px;
}
.uc-tab svg,
.uc-tab span {
  color: var(--text5);
  fill: var(--text5);
  opacity: 0.5;
}
.uc-tab.selected svg,
.uc-tab.selected span {
  color: var(--textBtn);
  fill: var(--textBtn);
  opacity: 1;
}
.uc-tab.selected {
  background: var(--primary);
  color: var(--textBtn);
}
.uc-tab:hover:not(.selected)::before {
  // background
  content: "";
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  background: var(--primary);
  opacity: 0.2;
  border-radius: 8px;
}

.uc-tab.selected::after {
  // the left pill of the tab
  content: "";
  position: absolute;
  border-radius: 1px;
  width: 2px;
  height: 8px;
  background-color: var(--textBtn);
  left: 0.5rem;
  top: 50%;
  transform: translateY(-50%);
}

.uc-tab svg {
  height: 1.5rem;
  width: 1.5rem;
  object-fit: contain;
}
.uc-tab.selected svg {
  fill: var(--textBtn);
}

.uc-section :deep(.el-table) {
  --el-table-bg-color: var(--background5);
  --el-table-tr-bg-color: var(--el-table-bg-color);
}
.uc-section :deep(.el-tabs__item) {
  height: 58px;
  line-height: 58px;
}
.uc-section :deep(.el-tabs__item:not(.is-active)) {
  color: var(--text5);
}
.uc-section :deep(.el-input) {
  --el-input-bg-color: rgba(0, 0, 0, 0.1);
  --el-input-text-color: var(--text5);
}
.uc-section-left.is-collapse .expend-sign {
  display: none;
}
.uc-section-left.is-collapse .collapse-sign {
  display: block;
}
.uc-section-left:not(.is-collapse) .expend-sign {
  display: block;
}
.uc-section-left:not(.is-collapse) .collapse-sign {
  display: none;
}
.el-menu {
  --el-menu-bg-color: transparent;
  --el-menu-border-color: unset;
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
  margin-top: 0.5rem;

  .el-menu-item,
  .el-menu-item:hover {
    all: unset;
  }
}

.menu-content {
  display: flex;
  flex-direction: column;
  margin-top: 0.5rem;
  margin-bottom: 0.5rem;
  gap: 0.5rem;
  .menu-item {
    display: flex;
    gap: 8px;
    align-items: center;
  }
}

.uc-section-left {
  .expand-btn {
    display: none;
  }
  .logout-btn {
    transition: none;
    height: 48px;
    --el-border-radius-base: 8px;
    display: flex;
    align-items: center;
    justify-content: center;
    &:hover svg {
      fill: #000;
    }
  }
  .hidden {
    display: none !important;
  }
  $breakpoint-tablet: 639px;
  @media screen and (min-width: 640px) and (max-width: 1023px) {
    .expand-btn {
      display: flex;
      background: #d3dec422;
      border-radius: 8px;
      color: white;
      width: 100%;
      height: 24px;
      justify-content: center;
      align-items: center;
    }
    &.is-collapse {
      .expand-btn {
        width: 56px;
      }
      .menu-content {
        .uc-tab {
          width: 56px;
        }
        .menu-item {
          .label {
            display: none;
          }
        }
      }
      .logout-btn {
        min-width: 0;
        width: 56px;
        .label {
          display: none;
        }
      }
    }
  }
}
@media (max-width: 639px) {
  .bg-cover {
    background: none;
  }
  .display_none {
    display: none !important;
  }
  .uc-section-title h3 {
    text-transform: capitalize;
    color: white;
    font-style: normal;
    font-weight: 900;
    font-size: 16px;
    line-height: 28px;
  }
  .uc-section {
    border-radius: 0px;
    display: flex;
    flex-direction: column;
  }
  .uc-section-right {
    overflow: auto;
  }
}
@media only screen and (max-width: 639px) {
  .uc-section-right div:first-child {
    height: auto;
  }
  .uc-section-left {
    display: none;
  }
  .user-section-container {
    margin: unset;
  }
}
.display_bloc {
  display: none;
}
@media (max-width: 639px) {
  .show_hidden_button_right {
    display: none;
  }
  .display_none {
    display: none !important;
  }
  .display_bloc {
    display: block;
  }
}

.uc-section-right {
  @media screen and (max-width: 639px) {
    min-height: calc(100vh - 52px); // header height
  }
}
  .uc-tab span {
    font-size: 14px;
  }

.user-center :deep(.el-overlay){
  background-color: rgba(0, 0, 0, 0.5);
}
</style>
